- Home
- API Enriched
- Network Security
- config
- Create Policy based Routing.
Create Policy based Routing.
const url = 'https://example-corp.console.ves.volterra.io/api/v1/api/production/us-east-1/namespaces/default/api/config/namespaces/example/policy_based_routings';const options = { method: 'POST', headers: {Authorization: '<Authorization>', 'Content-Type': 'application/json'}, body: '{"metadata":{"annotations":{},"description":"example","disable":true,"labels":{},"name":"example","namespace":"example"},"spec":{"forward_proxy_pbr":{"forward_proxy_pbr_rules":[{"all_destinations":{},"all_sources":{},"forwarding_class_list":[{"name":"example","namespace":"example"}],"http_list":{"http_list":[{"any_path":{},"exact_value":"example","path_exact_value":"example","path_prefix_value":"example","path_regex_value":"example","regex_value":"example","suffix_value":"example"}]},"ip_prefix_set":{"name":"example","namespace":"example"},"label_selector":{"expressions":["example"]},"metadata":{"description":"example","name":"example"},"prefix_list":{"prefixes":["example"]},"tls_list":{"tls_list":[{"exact_value":"example","regex_value":"example","suffix_value":"example"}]}}]},"forwarding_class_list":[{"name":"example","namespace":"example"}],"network_pbr":{"any":{},"label_selector":{"expressions":["example"]},"network_pbr_rules":[{"all_tcp_traffic":{},"all_traffic":{},"all_udp_traffic":{},"any":{},"applications":{"applications":["APPLICATION_HTTP"]},"dns_name":"example","forwarding_class_list":[{"name":"example","namespace":"example"}],"ip_prefix_set":{"ref":[{"name":"example","namespace":"example"}]},"metadata":{"description":"example","name":"example"},"prefix_list":{"prefixes":["example"]},"protocol_port_range":{"port_ranges":["example"],"protocol":"example"}}],"prefix_list":{"prefixes":["example"]}}}}'};
try { const response = await fetch(url, options); const data = await response.json(); console.log(data);} catch (error) { console.error(error);}curl --request POST \ --url https://example-corp.console.ves.volterra.io/api/v1/api/production/us-east-1/namespaces/default/api/config/namespaces/example/policy_based_routings \ --header 'Authorization: <Authorization>' \ --header 'Content-Type: application/json' \ --data '{ "metadata": { "annotations": {}, "description": "example", "disable": true, "labels": {}, "name": "example", "namespace": "example" }, "spec": { "forward_proxy_pbr": { "forward_proxy_pbr_rules": [ { "all_destinations": {}, "all_sources": {}, "forwarding_class_list": [ { "name": "example", "namespace": "example" } ], "http_list": { "http_list": [ { "any_path": {}, "exact_value": "example", "path_exact_value": "example", "path_prefix_value": "example", "path_regex_value": "example", "regex_value": "example", "suffix_value": "example" } ] }, "ip_prefix_set": { "name": "example", "namespace": "example" }, "label_selector": { "expressions": [ "example" ] }, "metadata": { "description": "example", "name": "example" }, "prefix_list": { "prefixes": [ "example" ] }, "tls_list": { "tls_list": [ { "exact_value": "example", "regex_value": "example", "suffix_value": "example" } ] } } ] }, "forwarding_class_list": [ { "name": "example", "namespace": "example" } ], "network_pbr": { "any": {}, "label_selector": { "expressions": [ "example" ] }, "network_pbr_rules": [ { "all_tcp_traffic": {}, "all_traffic": {}, "all_udp_traffic": {}, "any": {}, "applications": { "applications": [ "APPLICATION_HTTP" ] }, "dns_name": "example", "forwarding_class_list": [ { "name": "example", "namespace": "example" } ], "ip_prefix_set": { "ref": [ { "name": "example", "namespace": "example" } ] }, "metadata": { "description": "example", "name": "example" }, "prefix_list": { "prefixes": [ "example" ] }, "protocol_port_range": { "port_ranges": [ "example" ], "protocol": "example" } } ], "prefix_list": { "prefixes": [ "example" ] } } } }'Shape of the Network Policy based routing create specification.
Authorizations
Section titled “Authorizations”Parameters
Section titled “Parameters”Path Parameters
Section titled “Path Parameters”Namespace This defines the workspace within which each the configuration object is to be created. Must be a DNS_LABEL format. For a namespace object itself, namespace value will be ""
Request Bodyrequired
Section titled “Request Bodyrequired”This is the input message of the ‘Create’ RPC.
object
object
Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects.
object
Human readable description for the object.
A value of true will administratively disable the object.
Map of string keys and values that can be used to organize and categorize (scope and select) objects as chosen by the user. Values specified here will be used by selector expression.
object
This is the name of configuration object. It has to be unique within the namespace. It can only be specified during create API and cannot be changed during replace API. The value of name has to follow DNS-1035 format. Required: YES.
This defines the workspace within which each the configuration object is to be created. Must be a DNS_LABEL format. For a namespace object itself, namespace value will be ""
object
object
Network(L3/L4) routing policy rules.
URL(s) and domains policy for forward proxy for a connection type (TLS or HTTP)
object
object
object
Ordered list of forwarding Class to be used if no rule match.
Required: YES.
This type establishes a direct reference from one object(the referrer) to another(the referred). Such a reference is in form of tenant/namespace/name.
object
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name. Required: YES.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then tenant will hold the referred object’s(e.g. Route’s) tenant.
object
URLs for HTTP connections.
URL strings in form “HTTP://
object
object
Exclusive with [regex_value suffix_value] Exact domain name.
Exclusive with [any_path path_prefix_value path_regex_value] Exact Path to match.
Exclusive with [any_path path_exact_value path_regex_value] Prefix of Path e.g “/abc/xyz” will match “/abc/xyz/.*”
Exclusive with [any_path path_exact_value path_prefix_value] Regular Expression value for the Path to match.
Exclusive with [exact_value suffix_value] Regular Expression value for the domain name.
Exclusive with [exact_value regex_value] Suffix of domain names e.g “xyz.com” will match “*.xyz.com”
object
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name. Required: YES.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then tenant will hold the referred object’s(e.g. Route’s) tenant.
object
Expressions contains the Kubernetes style label expression for selections. Required: YES.
object
Human readable description.
This is the name of the message. The value of name has to follow DNS-1035 format. Required: YES.
object
List of IPv4 prefixes that represent an endpoint.
object
Domains in SNI for TLS connections.
Domains names.
object
Exclusive with [regex_value suffix_value] Exact domain name.
Exclusive with [exact_value suffix_value] Regular Expression value for the domain name.
Exclusive with [exact_value regex_value] Suffix of domain name e.g “xyz.com” will match “*.xyz.com” and “xyz.com”
Ordered list of forwarding Class to be used if source application match and no rule match.
Required: YES.
This type establishes a direct reference from one object(the referrer) to another(the referred). Such a reference is in form of tenant/namespace/name.
object
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name. Required: YES.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then tenant will hold the referred object’s(e.g. Route’s) tenant.
object
object
object
Expressions contains the Kubernetes style label expression for selections. Required: YES.
Network(L3/L4) routing policy rule.
Shape of Network PBR Rule.
object
object
object
object
object
object
Application protocols like HTTP, SNMP.
Exclusive with [any ip_prefix_set prefix_list] Resolve hostname to GET the IP.
Ordered list of forwarding Class to be used if rule match.
Required: YES.
This type establishes a direct reference from one object(the referrer) to another(the referred). Such a reference is in form of tenant/namespace/name.
object
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name. Required: YES.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then tenant will hold the referred object’s(e.g. Route’s) tenant.
object
A list of references to ip_prefix_set objects.
This type establishes a ‘direct reference’ from one object(the referrer) to another(the referred). Such a reference is in form of tenant/namespace/name for public API and Uid for private API This type of reference is called direct because the relation is explicit and concrete (as opposed to selector reference which builds a group based on labels of selectee objects)
object
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then kind will hold the referred object’s kind (e.g. “route”)
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then tenant will hold the referred object’s(e.g. Route’s) tenant.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then uid will hold the referred object’s(e.g. Route’s) uid.
object
Human readable description.
This is the name of the message. The value of name has to follow DNS-1035 format. Required: YES.
object
List of IPv4 prefixes that represent an endpoint.
object
List of port ranges. Each range is a single port or a pair of start and end ports e.g. 8080-8192.
Protocol in IP packet to be used as match criteria Values are TCP, UDP, and icmp.
object
List of IPv4 prefixes that represent an endpoint.
Responses
Section titled “Responses”A successful response.
object
object
Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects.
object
Human readable description for the object.
A value of true will administratively disable the object.
Map of string keys and values that can be used to organize and categorize (scope and select) objects as chosen by the user. Values specified here will be used by selector expression.
object
This is the name of configuration object. It has to be unique within the namespace. It can only be specified during create API and cannot be changed during replace API. The value of name has to follow DNS-1035 format. Required: YES.
This defines the workspace within which each the configuration object is to be created. Must be a DNS_LABEL format. For a namespace object itself, namespace value will be ""
object
object
Network(L3/L4) routing policy rules.
URL(s) and domains policy for forward proxy for a connection type (TLS or HTTP)
object
object
object
Ordered list of forwarding Class to be used if no rule match.
Required: YES.
This type establishes a direct reference from one object(the referrer) to another(the referred). Such a reference is in form of tenant/namespace/name.
object
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name. Required: YES.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then tenant will hold the referred object’s(e.g. Route’s) tenant.
object
URLs for HTTP connections.
URL strings in form “HTTP://
object
object
Exclusive with [regex_value suffix_value] Exact domain name.
Exclusive with [any_path path_prefix_value path_regex_value] Exact Path to match.
Exclusive with [any_path path_exact_value path_regex_value] Prefix of Path e.g “/abc/xyz” will match “/abc/xyz/.*”
Exclusive with [any_path path_exact_value path_prefix_value] Regular Expression value for the Path to match.
Exclusive with [exact_value suffix_value] Regular Expression value for the domain name.
Exclusive with [exact_value regex_value] Suffix of domain names e.g “xyz.com” will match “*.xyz.com”
object
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name. Required: YES.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then tenant will hold the referred object’s(e.g. Route’s) tenant.
object
Expressions contains the Kubernetes style label expression for selections. Required: YES.
object
Human readable description.
This is the name of the message. The value of name has to follow DNS-1035 format. Required: YES.
object
List of IPv4 prefixes that represent an endpoint.
object
Domains in SNI for TLS connections.
Domains names.
object
Exclusive with [regex_value suffix_value] Exact domain name.
Exclusive with [exact_value suffix_value] Regular Expression value for the domain name.
Exclusive with [exact_value regex_value] Suffix of domain name e.g “xyz.com” will match “*.xyz.com” and “xyz.com”
Ordered list of forwarding Class to be used if source application match and no rule match.
Required: YES.
This type establishes a direct reference from one object(the referrer) to another(the referred). Such a reference is in form of tenant/namespace/name.
object
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name. Required: YES.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then tenant will hold the referred object’s(e.g. Route’s) tenant.
object
object
object
Expressions contains the Kubernetes style label expression for selections. Required: YES.
Network(L3/L4) routing policy rule.
Shape of Network PBR Rule.
object
object
object
object
object
object
Application protocols like HTTP, SNMP.
Exclusive with [any ip_prefix_set prefix_list] Resolve hostname to GET the IP.
Ordered list of forwarding Class to be used if rule match.
Required: YES.
This type establishes a direct reference from one object(the referrer) to another(the referred). Such a reference is in form of tenant/namespace/name.
object
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name. Required: YES.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then tenant will hold the referred object’s(e.g. Route’s) tenant.
object
A list of references to ip_prefix_set objects.
This type establishes a ‘direct reference’ from one object(the referrer) to another(the referred). Such a reference is in form of tenant/namespace/name for public API and Uid for private API This type of reference is called direct because the relation is explicit and concrete (as opposed to selector reference which builds a group based on labels of selectee objects)
object
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then kind will hold the referred object’s kind (e.g. “route”)
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then tenant will hold the referred object’s(e.g. Route’s) tenant.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then uid will hold the referred object’s(e.g. Route’s) uid.
object
Human readable description.
This is the name of the message. The value of name has to follow DNS-1035 format. Required: YES.
object
List of IPv4 prefixes that represent an endpoint.
object
List of port ranges. Each range is a single port or a pair of start and end ports e.g. 8080-8192.
Protocol in IP packet to be used as match criteria Values are TCP, UDP, and icmp.
object
List of IPv4 prefixes that represent an endpoint.
object
CreationTimestamp is a timestamp representing the server time when this object was created. It is not guaranteed to be set in happens-before order across separate operations. Clients may not set this value. It is represented in RFC3339 form and is in UTC.
A value identifying the class of the user or service which created this configuration object.
A value identifying the exact user or service that created this configuration object.
DeletionTimestamp is RFC 3339 date and time at which this resource will be deleted. This field is set by the server when a graceful deletion is requested by the user, and is not directly settable by a client. The resource is expected to be deleted (no longer visible from resource lists, and not reachable by name) after the time in this field, once the finalizers list is empty. As long as the finalizers list contains items, deletion is blocked. Once the deletionTimestamp is set, this value may not be unset or be set further into the future, although it may be shortened or the resource may be deleted prior to this time. For example, a user may request that a pod is deleted in 30 seconds. The Kubelet will react by sending a graceful termination signal to the containers in the pod. After that 30 seconds, the Kubelet will send a hard termination signal (SIGKILL) to the container and after cleanup, remove the pod from the API. In the presence of network partitions, this object may still exist after this timestamp, until an administrator or automated process can determine the resource is fully terminated. If not set, graceful deletion of the object has not been requested.
Populated by the system when a graceful deletion is requested. Read-only.
Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.
object
Pending is a list of initializers that must execute in order before this object is initialized. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.
Initializer is information about an initializer that has not yet completed.
object
Name of the service that is responsible for initializing this object.
object
Suggested HTTP return code for this status, 0 if not set.
A human-readable description of why this operation is in the “Failure” status. If this value is empty there is no information available.
Status of the operation. One of: “Success” or “Failure”.
Map of string keys and values that can be used to organize and categorize (scope and select) objects as chosen by the operator or software. Values here can be interpreted by software(backend or frontend) to enable certain behavior e.g. Things marked as soft-deleted(restorable).
object
ModificationTimestamp is a timestamp representing the server time when this object was last modified.
Unique index for the object. Some objects need a unique integer index to be allocated for each object type. This field will be populated for all objects that need it and will be zero otherwise.
object
Kind of the view object.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.
UID of the view object.
Tenant to which this configuration object belongs to. The value for this is found from presented credentials.
Uid is the unique in time and space value for this object. It is generated by the server on successful creation of an object and is not allowed to change on Replace API. The value of is taken from uid field of ObjectMetaType, if provided.
Example
{ "spec": { "network_pbr": { "network_pbr_rules": [ { "applications": { "applications": [ "APPLICATION_HTTP" ] } } ] } }}Returned when operation is not authorized.
Examplegenerated
exampleReturned when there is no permission to access resource.
Examplegenerated
exampleReturned when resource is not found.
Examplegenerated
exampleReturned when operation on resource is conflicting with current value.
Examplegenerated
exampleReturned when operation has been rejected as it is happening too frequently.
Examplegenerated
exampleReturned when server encountered an error in processing API.
Examplegenerated
exampleReturned when service is unavailable temporarily.
Examplegenerated
exampleReturned when server timed out processing request.
Examplegenerated
example